/*͸*/
/*                                                                  */
/*  Program Name :  MOD.C                                           */
/*                                                                  */
/*        Author :  G. A. Szekely                                   */
/*                                                                  */
/*       Version :  1.0                                             */
/*                                                                  */
/* Creation Date :  08/09/94   06:31:52                             */
/*                                                                  */
/* Revision Date :  08/10/94                                        */
/*                                                                  */
/*͵*/
/*                                                                  */
/*   Description : This program is used with Starbase Corporation's   */
/*                 Codewright vers 3.0g to add ChromaCoding and     */
/*                 Language Template features to a Modula-2 source  */
/*                 code file being edited using Codewright.         */
/*                 This Modula-2 version was created by modifying   */
/*                 the Pascal version that original came with       */
/*                 Codewright.                                      */
/*                                                                  */
/*;*/




//#include <win_filt.h>
#include <windows.h>
#include <string.h>
#include <ctype.h>
#include <exports.h>
#include <cwstart.h>


#define MAX_BUF_LEN 100

static LPVOID _mod_hash_names = NIL;   /* pointer to the hash table containing */
                                       /* all 'Modula-2' keyword names.        */

static LPVOID _mod_hash_templates = NIL; /* pointer to the hash table containing */
                                         /* an abbreviated name and its template */

/* Define a structure to hold an abbreviation and the template to be
 * expanded when the abbreviation is entered into the buffer.
 * This structure will be the element in the hash table _mod_hash_templates.
 */
typedef struct _LanguageTemplate
   {
   LPSTR abbrev;
   LPSTR template;
   } LanguageTemplate;


/* This string contains all keyword names which will be indented an extra level.
 */
LPSTR PAS_INDENT_STR =
"\377BEGIN\377TYPE\377VAR\377CONST\377REPEAT\377IF\377ELSEIF\377ELSE\377ELSIF\377\
\377FOR\377RECORD\377FUNCTION\377PROCEDURE\377WHILE\377CASE\377WITH\377LOOP\377";


/*
 * _mod_templates[] contains the keyword abbreviation and the template for
 * the abbreviation.  To add a new name, insert it before the NIL entry or
 * call _mod_assign_template().
 *
 * The special characters within the template are:
 *
 *     \n - new line
 *     &  - cursor position after template insertion
 *     @  - backspace
 *     \c - insert 'c' literally
 */
LanguageTemplate _mod_templates[] =
   {
      { "B|BE|BEG|BEGI|BEGIN",        "BEGIN%0&%1END;"},
      { "CA|CAS|CASE",                "CASE & OF%0%1END;"},
      { "CO|CON|CONS|CONST",          "CONST%0&;"},
      { "E|EL|ELS|ELSE",              "ELSE%1" },
      { "EI|ELSI|ELSIF",              "ELSE IF (&)%1" },
      { "EN|END",                     "END;" },
      { "EX|EXP|EXPO|EXPOR|EXPORT",   "EXPORT &;"},
      { "F|FO|FOR",                   "FOR & :=  TO  DO%0%1END;"},
      { "FR|FRO|FROM",                "FROM & IMPORT%0;"},
      { "IF",                         "IF (&) THEN%0%1END;"},
      { "IMPO|IMPOR|IMPORT",          "IMPORT%0;"},
      { "L|LO|LOO|LOOP",              "LOOP %0&%1END;"},
      { "M|MO|MOD|MODU|MODUL|MODULE", "MODULE &;"},
      { "RET|RETU|RETUR|RETURN",      "RETURN (&);"},
      { "R|RE|REP|REPE|REPEA|REPEAT", "REPEAT%0&%1UNTIL ();"},
      { "T|TY|TYP|TYPE",              "TYPE %0&;"},
      { "U|UN|UNT|UNTI|UNTIL",        "UNTIL ();"},
      { "V|VA|VAR",                   "VAR%0&;"},
      { "WH|WHI|WHIL|WHILE",          "WHILE (&) DO%0%1END;"},
      { "WI|WIT|WITH",                "WITH (&) DO%0%1END;"},
      { "D|DE|DEF|DEFI|DEFIN|DEFINI|DEFINIT|DEFINITION",         "DEFINITION MODULE &;" },
      { "FU|FUN|FUNC|FUNCT|FUNCTI|FUNCTIO|FUNCTION",             "FUNCTION & ();%0%1END ;" },
      { "IM|IMP|IMPL|IMPLE|IMPLEM|IMPLEME|IMPLEMENTATION",       "IMPLEMENTATION MODULE &;" },
      { "P|PR|PRO|PROC|PROCE|PROCED|PROCEDU|PROCEDUR|PROCEDURE", "PROCEDURE & ();%0%1END ;" },

      { "b|be|beg|begi|begin",        "begin%0&%1end;"},
      { "ca|cas|case",                "case & of%0%1end;"},
      { "co|con|cons|const",          "const%0&;"},
      { "e|el|els|else",              "else%1" },
      { "ei|elsi|elsif",              "else if (&)%1" },
      { "en|end",                     "end;" },
      { "ex|exp|expo|expor|export",   "export &;"},
      { "f|fo|for",                   "for & :=  to  do%0%1end;"},
      { "fr|fro|from",                "from & import%0;"},
      { "if",                         "if (&) then%0%1end;"},
      { "impo|impor|import",          "import%0;"},
      { "l|lo|loo|loop",              "loop %0&%1end;"},
      { "m|mo|mod|modu|modul|module", "module &;"},
      { "ret|retu|retur|return",      "return (&);"},
      { "r|re|rep|repe|repea|repeat", "repeat%0&%1until ();"},
      { "t|ty|typ|type",              "type %0&;"},
      { "u|un|unt|unti|until",        "until ();"},
      { "v|va|var",                   "var%0&;"},
      { "wh|whi|whil|while",          "while (&) do%0%1end;"},
      { "wi|wit|with",                "with (&) do%0%1end;"},
      { "d|de|def|defi|defin|defini|definit|definition",         "definition module &;" },
      { "fu|fun|func|funct|functi|functio|function",             "function & ();%0%1end ;" },
      { "im|imp|impl|imple|implem|impleme|implementation",       "implementation module &;" },
      { "p|pr|pro|proc|proce|proced|procedu|procedur|procedure", "procedure & ();%0%1end ;" },

      {NIL, NIL},
   };

/* Define the list of 'Modula-2' keyword names to appear in
 * the keyword color if language coloring is enabled.
 */
LPSTR _mod_names[] =
   {
   /* Modula-2 Reserved Words */
   "ABS",          "ABSOLUTE",     "ADDRESS",      "ADR",          "AND",
   "ARRAY",        "ASM",          "ASSEMBLER",    "BEGIN",        "BITSET",
   "BOOLEAN",      "BY",           "BYTE",         "BYTESET",      "CAP",
   "CARDINAL",     "CASE",         "CHAR",         "CHR",          "CLASS",
   "CONST",        "CONSTRUCTOR",  "DEC",          "DEFINITION",   "DESTRUCTOR",
   "DISPOSE",      "DIV",          "DO",           "DOWNTO",       "ELSE",
   "ELSIF",        "END",          "EXCL",         "EXIT",         "EXPORT",
   "EXPORTS",      "EXTERNAL",     "FALSE",        "FAR",          "FARADDRESS",
   "FARADR",       "FARNIL",       "FIELDOFS",     "FILE",         "FILL",
   "FIXREAL",      "FLOAT",        "FOR",          "FORWARD",      "FROM",
   "FUNCTION",     "GOTO",         "HALT",         "HIGH",         "IF",
   "IMPLEMENTATION","IMPORT",      "IN",           "INC",          "INCL",
   "INLINE",       "INTEGER",      "INTERFACE",    "INTERRUPT",    "LABEL",
   "LIBRARY",      "LONGCARD",     "LONGINT",      "LONGREAL",     "LONGWORD",
   "LOOP",         "LOW",          "MAX",          "MIN",          "MOD",
   "MODULE",       "NEAR",         "NEARADDRESS",  "NEARADR",      "NEARNIL",
   "NEW",          "NIL",          "NOT",          "NULLPROC",     "OBJECT",
   "ODD",          "OF",           "OFFSET",       "OFS",          "OR",
   "ORD",          "PACKED",       "POINTER",      "PRIVATE",      "PROC",
   "PROCEDURE",    "PROGRAM",      "QUALIFIED",    "REAL",         "RECORD",
   "REPEAT",       "RETURN",       "SEG"           "SEGMENT",      "SELF",
   "SET",          "SHL",          "SHORTADR",     "SHORTCARD",    "SHORTINT",
   "SHR",          "SIZE",         "STRING",       "TEMPREAL",     "TEXT",
   "THEN",         "TO",           "TRUE",         "TRUNC",        "TYPE",
   "UNIT",         "UNTIL",        "USES",         "VAL",          "VAR",
   "VIRTUAL",      "VSIZE",        "WHILE",        "WITH",         "WORD",
   "XOR",

   /* Modula-2 Math Functions */
   "ACOS",         "ASIN",         "ATAN",         "ATAN2",        "COS",
   "COSH",         "EXP",          "LOG",          "LOG10",        "MOD",
   "POW",          "SIN",          "SINH",         "SQRT",         "TAN",
   "TANH",

   /* Modula-2 Language Extensions */
   "ALL",          "BIASED",       "CALCONST",     "CLEAR",        "DISCRETE",
   "EQUATION",     "FIX",          "HANDLER",      "INTERPROCESS", "INTERNAL",
   "INTERPOLATION","IOTRANSFER",   "LIMIT",        "LIMHI",        "LIMLO",
   "NEWPROCESS",   "NONREENTRANT", "OLIMHI",       "OLIMLO",       "OLIMIT",
   "PDEC",         "PINC",         "PRAGMA",       "PRECISION",    "PREC",
   "PROCESS",      "RETYPE",       "ROM",          "SAFE",         "STATE",
   "SYSTEM",       "TABLE_2D",     "TABLE_3D",     "TRANSFER",     "TRANSFORM",
   "TSIZE",        "UNILITERAL", "UNIVERSAL_FIXED","UNIVERSAL_INT","UNIVERSAL_REAL",
   "VOLATILE",

   NIL,
   };


 long DLL _mod_in_comment (long offset);
 long DLL _mod_find_comment_start (void);
 long DLL _mod_find_comment_end (int curly);

void DLL _mod_init (void);
void DLL _init (void);
BOOL DLL _mod_expand (void);
void DLL _mod_language_colors_update (long firstline, long lastline);
void DLL _mod_language_colors (long numlines);
void DLL _mod_assign_template (LPSTR abbrev, LPSTR template);
void DLL _mod_add_keyword (LPSTR keyword);
BOOL DLL _mod_indent (void);



LIBMAIN            /* defines the LibMain () function for Borland C */


/* When this DLL is first loaded either by LibPreLoad() or LibAutoLoad(),
 * the function _init () is invoked.  Within this function, all DLL specific
 * initialization should be performed such as:
 *
 *         - Defining any module global keystrokes or keymaps to be used
 *         - Exporting any functions to be accessed through LibFunctionExec()
 *         - Autoloading any other DLLs.
 *
 */

void DLL 
_init()
{
	_mod_init();
}


/*
 ** _mod_init ()
 *
 *  Initialize this module by exported any required functions and
 *  the hash tables needed to support indenting, template expansion
 *  and keyword coloring.
 */
void DLL _mod_init (void)
   {
   static BOOL firstTime = TRUE;
   int i;

   if (firstTime)
      {
      LibExport ("BOOL _mod_expand");
      LibExport ("_mod_assign_template LPSTR LPSTR");
      LibExport ("_mod_add_keyword LPSTR");
      LibExport ("BOOL _mod_indent( void ) ");
      LibExport ("_mod_language_colors_update long long");
      LibExport ("_mod_language_colors long");
      LibExport ("_mod_in_comment long");
      LibExport ("_mod_find_comment_start void"); 
      LibExport ("_mod_find_comment_end int");
               LibExport ("_mod_routines");                

      firstTime = FALSE;

      /* Create a hash table to hold all of the 'Modula-2' keyword names. */
      _mod_hash_names = HashCreateTable (43,  /* a prime # */
                                         sizeof (LPSTR), HASH_IGN_CASE);
      i = 0;

      while (_mod_names[i] != NIL)
         {
         LPSTR XFAR *lpf = (LPSTR XFAR *) HashGetEntry (_mod_hash_names,
                                                        _mod_names[i],
                                                        strlen (_mod_names[i]));

         if (lpf)
            *lpf = StrNew (_mod_names[i]);
         i++;
         }   /* while _mod_names */

      /* Create a hash table to hold all of the 'Modula-2' template names. */
      _mod_hash_templates = HashCreateTable (59, /* a prime # */
                                             sizeof (LPSTR), HASH_IGN_CASE);
      i = 0;

      while (_mod_templates[i].abbrev != NIL)
         {
         _mod_assign_template (_mod_templates[i].abbrev, _mod_templates[i].
                               template);
         i++;
         }   /* while _mod_templates */
      }   /* if firstTime */
   }   /* function DLL _mod_init */


/*
 ** _mod_expand ()
 *
 *  DESCRIPTION:
 *    Attempts to perform 'Modula-2' language template expansion.  This function
 *    is normally bound to the <SPACE> key.  When invoked, it reads the
 *    previous word.  If the word is in the list of defined templates,
 *    the template is extracted and inserted.  Some characters in the
 *    templates have special meanings. They are:
 *
 *       \n - new line
 *       &  - cursor position after template insertion
 *       @  - backspace
 *       \  - take next character literally
 */
BOOL DLL _mod_expand (void)
   {
   LPVOID htEntry;
   LPSTR _mod_string = NULL;
   LPSTR str;
   int i = 0;

   MarkSavePos ();

   /* Check to see if we are currently positioned inside a 'Modula-2' comment. */
   if (_mod_in_comment (-1L) != -1)
      goto _mod_expand_incomplete;

   str = BufReadStr (65535L);
   while (str[i] && !isspace(str[i]))
      i++;
   str[i] = '\0';

   _mod_string = StrTrim (str, " \t");
   StrFree (str);

   if (!_mod_string)
      goto _mod_expand_incomplete;

   /* Search for a keyword match in the hash table. */
   htEntry = HashFindEntry (_mod_hash_templates, _mod_string, strlen (
                            _mod_string));

   if (htEntry)
      {
      /* A template exists for the current keyword, delete the keyword
       * and insert the template.
       */
      MarkDropPos (1);
      str = *(LPSTR *) htEntry;
      BufDelChar (lstrlen (_mod_string));

      _ext_expand_template (str);
      }   /* if htEntry */
   else
      goto _mod_expand_incomplete;
   StrFree (_mod_string);
   return TRUE;

   _mod_expand_incomplete:
   StrFree (_mod_string);
   MarkRestorePos ();

   return FALSE;
   }   /* function DLL _mod_expand */

/*
 ** _mod_language_colors_update ()
 *
 *  This function does an intermediate update of the colors within
 *  a range of line numbers (firstline and lastline).  It must also
 *  determine if the first and last line specified are within a
 *  comment and act appropriately.
 */
void DLL _mod_language_colors_update (long firstline, long lastline)
   {
   long startoff;
   long ec_line = 0;                   /* end comment line */
   int curlycomment = -1;              /* -1 = don't care, 0 = paren type, 1 = curly */

   if (firstline && lastline)
      {
      /* Begin coloring at the previous comment if
       * currently located in the middle of one.
       */
      _PosInit (0);
      if (firstline == 1)
         _PosPrevLine (0L);
      else
         _PosNextLine (firstline - 1);

      startoff = _PosQOffset ();
      if (_mod_find_comment_start () == 1)
         {
         startoff = _PosQOffset ();
         curlycomment = (_PosCurrentChar () == '{') ? 1 : 0;

         _PosNextChar ();              /* move off of the comment */
         _PosNextChar ();

         if (_mod_find_comment_end (curlycomment))
            ec_line = _PosQLine ();

         _PosInit (startoff);
         firstline = _PosQLine ();
         }   /* if _mod_find_comment_start */

      /* End coloring at the next comment if
       * currently located in the middle of one.
       */
      _PosInit (0);
      _PosNextLine (lastline - 1);
      _PosNextLine (0);

      if (_PosQColor ())
         {
         _mod_find_comment_end (curlycomment);
         lastline = _PosQLine ();
         }   /* if _PosQColor */
      else if (_mod_find_comment_end (curlycomment) == 2)
         lastline = _PosQLine ();

      SysSetSystemFlags (SysQSystemFlags () | SYSTEM_DELAY_ATTR_CHANGES);

      if (!ec_line)
         AttrSetColor (firstline, lastline, 1L, 0x7FFFFFFFL, 0);
      else if (ec_line < lastline)
         {
         AttrSetColor (ec_line, lastline, 1L, 0x7FFFFFFFL, 0);
         if (ec_line < firstline)
            firstline = ec_line;
         }   /* else if ec_line */

      /* Reset the attributes for the line range within _c_language_colors. */
      _PosInit (startoff);
      _mod_language_colors (lastline - firstline + 1);

      /* Allow changes to be redraw */
      SysClrSystemFlags (SYSTEM_DELAY_ATTR_CHANGES);
      WinRedrawLines (WinQCurrentWindow (), firstline, lastline);
      }   /* if firstline */
   }   /* function DLL */

/*
 ** _mod_language_colors()
 *
 * If numlines == -1, start from the top of the buffer and encode all of them,
 * otherwise start at the current location of the number of lines specified.
 *
 * It is assumed that if numlines != -1, that _PosInit() has been called
 * and numlines is relative to the current position.
 */
void DLL _mod_language_colors (long numlines)
   {
   long startoff;
   long startline;
   long endoff;
   WORD ch;
   LPSTR buf;
   int i = 0;
   int comment_color = ColorComments (-1);
   int keyword_color = ColorKeywords (-1);
   int quote_color = ColorAlternate1 (-1);
   int number_color = ColorAlternate2 (-1);
   int brace_color  = ColorAlternate3( -1 );
   int preproc_color = ColorAlternate4 (-1);
   int curlycomment;


   /* Set Visible Left Margin at column number 72                    */
   /* WinVisibleMarginColumn (72); */

   buf = (LPSTR) MemAlloc (MAX_BUF_LEN);

   /* Start at the top of the buffer or current position. */
   if (numlines == -1)
      {
      _PosInit (0);
      numlines = 0x7FFFFFFFL;
      }   /* if numlines */
   else
      {
      startoff = _PosQOffset ();
      startline = _PosQLine ();
      endoff = _mod_in_comment (startoff);
      if (endoff == -1)
         _PosInit (startoff);
      else
         {
         _PosInit (endoff);
         numlines += (startline - _PosQLine ());
         }   /* else */
      }   /* else */
   ch = _PosCurrentChar ();
   startoff = _PosQOffset ();


   while ((ch != EOF_CHAR) && (numlines > 0))
      {
      if (ch == '\n')
         numlines--;

      if ((ch == '\'') || (ch == '\"'))
         {
         UINT quote = ch;

         startoff = _PosQOffset ();

         do {
            ch = _PosNextChar ();
            if (ch == '\\')
               {
               ch = _PosNextChar ();
               if ((ch == quote) || (ch == '\\'))
                  ch = _PosNextChar ();
               }   /* if ch */
            if ((ch == EOF_CHAR) || (ch == '\n'))
               break;
            } while (ch != quote);

         if (ch == quote)
            ch = _PosNextChar ();

         /* color the string */
         if (quote_color)
            {
            endoff = _PosQOffset ();
            _PosInit (startoff);
            _PosSetColor (quote_color, endoff - startoff);
            _PosInit (endoff);
            }   /* if quote_color */
         continue;
         }   /* if ch */

      /* parenthesis color */
      else if (brace_color && _fstrchr("()", ch) != 0)
         {
         long coff;

         coff = _PosQOffset ();
         _PosInit (coff);
         _PosSetColor (brace_color, 1);
         _PosInit (coff);
         }  /* else if brace_color */

       /* preprocessor commands  */
       else if ( ch == '#' && preproc_color)
         {
         startoff = _PosQOffset ();
         do {
            ch = _PosNextChar ();
            } while (ch == ' ' || ch == '\t');
         do {
            ch = _PosNextChar();
            } while ( !isspace(ch) && ch != EOF_CHAR);
         endoff = _PosQOffset();
         _PosInit (startoff);
         _PosSetColor (preproc_color, endoff - startoff);
         _PosInit (endoff);
         continue;
         }   /* else if ch */

      /*  digit  */
      else if (number_color && isdigit( ch ))
         {
         int j = 0;
         UINT lastch = _PosPrevChar ();

         if (lastch != EOF_CHAR)
            _PosNextChar ();

         startoff = _PosQOffset ();
         do {
            j++;
            ch = _PosNextChar ();
            } while (isxdigit( ch ) || (ch == '.') || (ch == 'x' && j == 1));

         if ((lastch != ' '
             && lastch != '\t'
             && lastch != '\r'
             && lastch != '\n'
             && lastch != EOF_CHAR
             && !ispunct( lastch ))
             || lastch == '_'
             || (ch == '_'))
            continue;

         if (ch == 'l' || ch == 'L')
            ch = _PosNextChar ();

         endoff = _PosQOffset ();
         _PosInit (startoff);
         _PosSetColor (number_color, endoff - startoff);
         _PosInit (endoff);
         continue;
         }   /* else if number_color */

      /*  character  */
      else if (isalnum( (BYTE)ch ) || (ch == '_'))
         {
         WORD lastch = _PosPrevChar ();

         if (lastch != EOF_CHAR)
            _PosNextChar ();

         i = 0;
         startoff = _PosQOffset ();

         do {
            if (i < MAX_BUF_LEN)
               buf[i++] = (char) ch;
            ch = _PosNextChar ();
            } while (isalpha( (BYTE)ch ) || (ch == '_'));

         if ((lastch != ' '
             && lastch != '\t'
             && lastch != '\r'
             && lastch != '\n'
             && lastch != EOF_CHAR
             && !ispunct( lastch ))
             || (ch == '_'))
            i = 0;
         continue;
         }   /* else if isalnum */
      else if (i)
         {
         if (HashFindEntry (_mod_hash_names, buf, i))
            {
            endoff = _PosQOffset ();
            _PosInit (startoff);
            _PosSetColor (keyword_color, endoff - startoff);
            _PosInit (endoff);
            }   /* if HashFindEntry */
         i = 0;
         }   /* else if i */

      if (ch == '(' || ch == '{')
         {
         startoff = _PosQOffset ();
         if (ch == '(')
            {
            curlycomment = FALSE;
            ch = _PosNextChar ();
            }   /* if ch */
         else
            curlycomment = TRUE;

         if (ch == '*' || ch == '{')
            {
            ch = _PosNextChar ();
            while (ch != EOF_CHAR)
               {
               if (ch == '\n')
                  numlines--;
               else if (ch == '*' || ch == '}')
                  {
                  if (ch == '*')
                     ch = _PosNextChar ();
                  if ((ch == ')' && !curlycomment)
                      || (ch == '}' && curlycomment))
                     {
                     endoff = _PosQOffset ();
                     _PosInit (startoff);
                     _PosSetColor (comment_color, endoff - startoff + 1);
                     _PosInit (endoff);
                     break;
                     }   /* if ch */
                  else if (ch != '}')
                     continue;
                  }   /* else if ch */
               ch = _PosNextChar ();
               }   /* while ch */
            ch = _PosNextChar ();
            }   /* if ch */
         continue;
         }   /* if ch */

      ch = _PosNextChar ();
      }   /* while ch */
   MemFree (buf);
   }   /* function DLL _mod_language_colors_update */


void DLL _mod_add_keyword (LPSTR keyword)
   {
   if (keyword && *keyword)
      {
      LPSTR XFAR *lpf = (LPSTR XFAR *) HashGetEntry (_mod_hash_names,
                                                     keyword, strlen (keyword))
      ;

      if (lpf)
         *lpf = StrNew (keyword);
      }   /* if keyword */
   }   /* function DLL _mod_add_keyword */


/*
 ** _mod_assign_template ()
 *
 *  PARAMETERS:
 *    abbrev   - the keyword abreviation used to locate a template
 *    template - the encoded template string associated with 'abbrev'
 *
 *  DESCRIPTION:
 *    Provide a means of adding or modifying 'Modula-2' template strings
 *    without changing the code.
 */
void DLL _mod_assign_template (LPSTR abbrev, LPSTR template)
   {
   _ext_assign_template (_mod_hash_templates, abbrev, template);
   }   /* function DLL _mod_assign_template */


/*
 ** _mod_indent ()
 *
 *  DESCRIPTION:
 *    Attempts to perform 'Modula-2' language smart indenting.  This function
 *    will behave differently based on the following conditions:
 *
 *    1. Within a comment - normal indentation
 *
 *    2. Not positioned at end of line - normal indentation
 *
 *    3. Current line prefixed by a name in PAS_INDENT_STR - perform smart
 *       indentation.  This may include skipping the next line if
 *       it consists only of an 'BEGIN' statement.
 */
BOOL DLL _mod_indent (void)
   {
   long curline;
   long col;
   LPSTR _mod_string;
   LPSTR str;
   long matchpos;

   MarkSavePos ();

   curline = BufQCurrentLine ();

   /* Check to see if we are currently positioned inside a 'Modula-2' comment. */
   if (_mod_in_comment (-1L) != -1)
      goto _mod_indent_incomplete;

   /* Not in a comment so indent according to the current 'Modula-2' construct. */
   if (!SrchFind ("^[ \t]*[a-zA-Z_]+\\c([ \t]|$)", SEARCH_REGEX, NIL)
       || (BufQCurrentLine () != curline))
      goto _mod_indent_incomplete;

   /* Read the keyword at the beginning of the current line. */
   col = BufQCurrentCol ();
   SrchFind ("(^|[^a-zA-Z_])\\c[a-zA-Z_]", SEARCH_REGEX, NIL);
   str = BufReadStr (col - BufQCurrentCol ());
   _mod_string = StrTrim (str, " \t");
   StrFree (str);

   /* Set prefix and suffix to \377 to perform a quick lookup of the name. */
   str = StrNew ("\377");
   _mod_string = StrAppend (_mod_string, str);
   str = StrAppend (str, _mod_string);
   StrFree (_mod_string);

   matchpos = StrMatch (str, PAS_INDENT_STR, SEARCH_IGCASE | SEARCH_FORWARD,
                        NIL);
   StrFree (str);

   if (!matchpos)
      /* Not a 'Modula-2' keyword, do normal indentation. */
      goto _mod_indent_incomplete;

   MarkRestorePos ();

   _ext_insert_indented_EOL ();
   BufInsertChar ('\t');
   return TRUE;

   _mod_indent_incomplete:
   MarkRestorePos ();

   return FALSE;
   }   /* function DLL _mod_indent */



/*--  Private functions --*/


/*
 ** _mod_in_comment ()
 *
 *  Determines whether or not the current position in the buffer is
 *  located within a 'PASCAL' comment by search backward for a '(*' or '{'
 *  comment declaration.
 *
 *  Returns -1   if not in a comment
 *          >= 0 indicates the offset in the buffer where the comment begins
 */


long DLL _mod_in_comment (long offset)
   {
   WORD ch;

   /* Check to see if we are currently positioned inside a 'Modula-2' comment
    */

   _PosInit (offset);
   ch = _PosCurrentChar ();

   do {
      switch (ch)
         {
         case '*':
            ch = _PosPrevChar ();
            if (ch == '(')             /* Found the beginning of a comment */
               return _PosQOffset ();  /* currrent line is in a comment    */
            break;
         case '{':
            return _PosQOffset ();     /* currrent line is in a comment */
         case ')':
            ch = _PosPrevChar ();
            if (ch == '*')             /* Found the beginning of a comment */
               return -1;              /* currrent line is not in a comment */
            break;
         case '}':
            return -1;
         default:
            ch = _PosPrevChar ();
            break;
         }   /* switch ch */
      } while (ch != EOF_CHAR);

   return -1L;
   }   /* function _mod_in_comment */

/*
 ** _mod_find_comment_start()
 *
 *  Search backwards for a 'Modula-2' comment sequence. Return 1 if { found
 *  and 2 if } found, 0 otherwise. Leave the current position
 *  at the beginning of the found comment.
 */
long DLL  _mod_find_comment_start (void)
   {
   WORD ch = _PosCurrentChar ();

   do {
      switch (ch)
         {
         case '*':
            ch = _PosPrevChar ();
            if (ch == '(')
               return 1;
            break;
         case ')':
            ch = _PosPrevChar ();
            if (ch == '*')
               return 2;
            break;
         case '{':
            return 1;
         case '}':
            return 2;
         default:
            ch = _PosPrevChar ();
            break;
         }   /* switch ch */
      } while (ch != EOF_CHAR);
   return 0;
   }   /* function _mod_find_comment_start */

/*
 ** _mod_find_comment_end ()
 *
 *      int  curly == -1 = don't care, 0 = paren type, 1 = curly
 *
 *  Search forwards for a 'Modula-2' comment sequence. Return 1 if { found
 *  and 2 if } found, 0 otherwise.  Leave the current position
 *  at the end of the found comment.
 */
long DLL _mod_find_comment_end (int curly)
   {
   WORD ch = _PosCurrentChar ();

   do {
      switch (ch)
         {
         case '*':
            ch = _PosNextChar ();
            if ((curly != 1) && ch == ')')
               return 2;
            break;
         case '(':
            ch = _PosNextChar ();
            if ((curly != 1) && ch == '*')
               return 1;
            break;
         case '{':
            if (curly != 0)
               return 1;
         case '}':
            if (curly != 0)
               return 2;
         default:
            ch = _PosNextChar ();
         }   /* switch ch */
      } while (ch != EOF_CHAR);
   return 0;
   }   /* function _mod_find_comment_end */



void DLL _mod_routines (void)
   {
   if (Grep (
   "^(([Pp](ROCEDURE|rocedure))|([Ff](unction|UNCTION)))[ \t]+[a-zA-Z0-9_]+.*$"
   ))
      MsgMessage ("");
   else
      MsgMessage ("No routines found.");
   }   /* function DLL _mod_routines */



